/* @(#) tssa.h 1.16 96/08/26 12:02:38 */
/* /home/carrie/dist/tssa/SCCS/s.tssa.h */

/******************************************************************************/
/*  Copyright (C) 1996  Carrie Wager and Mark Segal.                          */
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 */
/*                                                                            */
/*  You may contact the authors via email: cwager@hsph.harvard.edu            */
/*  or mark@biostat.ucsf.edu, or by snail mail at:                            */
/*                                                                            */
/*  --------------------------------------------------------------------      */
/*  | Mark Segal                                                        |     */
/*  | Division of Biostatistics, University of California,  MU 420 West |     */
/*  | 500 Parnassus Avenue,  San Francisco,  CA  94143-0560             |     */
/*  --------------------------------------------------------------------      */
/******************************************************************************/


/* define TSSA_SA when compiling for standalone */

/* header files  */
#include <stdio.h>
#include <string.h>
#include <math.h>

/* max length of variable names from control file for standalone */
#define NAMELENGTH 9

#ifndef TSSA_SA
#include "S.h"
#define mySalloc(var,size,type) var = Calloc(size, type);
#else
#include <malloc.h>
#define mySalloc(var,size,type) if( ((var)=(( type*) malloc( (size) * sizeof(type))))==( type *) NULL) \
          { \
           printf("Could not allocate %d bytes for var\n",(size) * sizeof(type)); \
          } 
#define Free(p) free(p)
#endif

/* macro for bidimensional array access (no memory copying) */
#define GX(i,j) (gX[kN*(j)+(i)])

/* function prototypes */
int tssa();
int control();
int readin();
void partit();
void coord();
void set();
void ties();
void kaplan_meier();
void printkm();
void kmmedian();
void deviations();
void weights();
void inital();
void shell();
double tarwar();
void reorder();
void terminal();
void traverse();
void detail();
void maxsubsplt();

/* type definitions */
struct plot
{
	double         *t_axis;
	double         *S_axis;
};
struct node
{
	int             father;
	int             first;
	int             last;
	int             left;
	int             right;
	int             NumDistUnc;
	int             spl_coord;
	int             keep;
	double          spl_stat;
	double          spl_value;
	struct plot     survcurv;
	double          median;
	double          absdev;
	int             snodenum;
	int             sorder;
};
